#include "pm.h"

int main()
{   ifstream entrada("DatosDeEntrada_Vehculos.dat",ios::in);
    ofstream salida("salidaTSPViajero.txt");//salida
	double *dels,*drowlo, *drowup, *dcollo, *dcolup, *dobj, *costos;
    int *mcolindx,*mrowindx; //indices
	int ncols,nelements,nrows,i,n1,j,k;

	//mximo 100 nudos y 10000 elementos no nulos;
	nrows=1000;ncols=1000;nelements=10000;

	// Reserva de memoria
	dels=new double[nelements];
	mcolindx=new int[nelements];mrowindx=new int[nelements];
	drowlo=new double[nrows];drowup=new double[nrows];
	dcollo=new double[ncols];dcolup=new double[ncols]; dobj=new double[ncols];
	costos=new double[ncols];

// Lectura de datos, ndice inicial 0
	//nmero de nudos n1;
	entrada>>n1;        
//Lectura de costos, funcin objetivo;Los mismos costos en cada tramo;
	for (i=0;i<n1;i++) for (j=0;j<n1;j++) entrada >> costos[i+j*n1];

//Pasar los coeficientes de la funcin objetivo y cotas de las variables
//Tramos n1 porque hay que volver al origen;
for(k=0;k<n1;k++) {
	for (i=0;i<n1;i++){
		for (j=0;j<n1;j++){
			dobj[i+j*n1+k*n1*n1]=costos[i+j*n1];
			dcollo[i+j*n1+k*n1*n1]=0;
			dcolup[i+j*n1+k*n1*n1]=1;
			if(i==j) dcolup[i+j*n1+k*n1*n1]=0; // no de i a i
		} }}
int *enteras; enteras=new int[n1*n1*n1];

int neleproblem=0;  
int rowsproblem=0;

//		RESTRICCIONES:

//Origen 0 tramo 0
drowlo[rowsproblem]=1; drowup[rowsproblem]=1;
	for (j=0;j<n1;j++){
		if(j!=0){
			dels[neleproblem]=1; 
			mcolindx[neleproblem]=j*n1;
			mrowindx[neleproblem]=rowsproblem;
			neleproblem++; }}
rowsproblem++;

//Cada origen
for (i=0;i<n1;i++){
	drowlo[rowsproblem]=1; drowup[rowsproblem]=1;
	for (j=0;j<n1;j++){
		for(k=0;k<n1;k++) {
			dels[neleproblem]=1; 
			mcolindx[neleproblem]=i+j*n1+k*n1*n1;
			mrowindx[neleproblem]=rowsproblem;
			neleproblem++;}}
rowsproblem++;}

//Cada tramo
for (k=0;k<n1;k++){
	drowlo[rowsproblem]=1; drowup[rowsproblem]=1;
	for(i=0;i<n1;i++){
		for(j=0;j<n1;j++) {
			dels[neleproblem]=1; 
			mcolindx[neleproblem]=i+j*n1+k*n1*n1;
			mrowindx[neleproblem]=rowsproblem;
			neleproblem++;} }
rowsproblem++;}

//Cada destino
for (j=0;j<n1;j++){
	drowlo[rowsproblem]=1; drowup[rowsproblem]=1;
	for (i=0;i<n1;i++){
		for(k=0;k<n1;k++) {
			dels[neleproblem]=1; 
			mcolindx[neleproblem]=i+j*n1+k*n1*n1;
			mrowindx[neleproblem]=rowsproblem;
			neleproblem++;} }
rowsproblem++;}

//Conservacion Y Eliminacin de subciclos.
for (j=0;j<n1;j++){	
	for(k=0;k<n1-1;k++) {
		drowlo[rowsproblem]=0; drowup[rowsproblem]=0;
		for (i=0;i<n1;i++){
			if(i!=j){
				dels[neleproblem]=1; 
                mcolindx[neleproblem]=i+j*n1+k*n1*n1;
                mrowindx[neleproblem]=rowsproblem;
				neleproblem++;}
						} 
		for (int r=0;r<n1;r++){
			if(r!=j){
				dels[neleproblem]=-1; 
                mcolindx[neleproblem]=j+r*n1+(k+1)*n1*n1;
                mrowindx[neleproblem]=rowsproblem;
				neleproblem++;}
						}
rowsproblem++;}}

//			RESOLUCIN:

//Matriz por indices
	OsiClpSolverInterface sol1;
	CoinPackedMatrix A(true,mrowindx,mcolindx,dels,neleproblem);
	sol1.loadProblem(A,dcollo,dcolup,dobj,drowlo,drowup);
	sol1.setObjSense(1); 
//salvar en formato mps;
	sol1.writeMps("TSPViajero");
//Solucin inicial lineal
	sol1.initialSolve(); 
	for (i=0;i<n1*n1*n1;i++)  enteras[i]=i;
	for (i=0;i<n1*n1*n1;i++) sol1.setInteger(enteras[i]);

//	Branch and Bound:


sol1.branchAndBound();
salida<<"\n Nmero de nudos:"<<n1;
salida<< "\n Funcin objetivo:"<< sol1.getObjValue(); 
salida<< "\n Nmero de variables:"<< sol1.getNumCols();
salida<< "\n Nmero de condiciones:"<< sol1.getNumRows();
salida<<"\n La  solucin actual  es:\n"; 
salida<< "\n ";
for(k=0;k<n1;k++){
	for(j=0;j<n1;j++){
		for(i=0;i<n1;i++){
			if(sol1.getColSolution()[k*n1*n1+j*n1+i]!=0){
				salida<< "Tramo ****** "<< k+1<<"\n";
				salida<<"Origen "<<i+1<<"  Destino "<<j+1<<"  "<<"\n ";}
		} }}

entrada.close();
salida.close();
return 0;
}  

